# default | pokemon-rogue-battle
Documentation for pokemon-rogue-battle

# Class default

#### Hierarchy (View Summary)

- SceneBase
  - default

- Defined in src/battle-scene.ts:203

##### Index

### Constructors

constructor

### Properties

abilityBar
add
anims
arena
arenaBg
arenaBgTransition
arenaEnemy
arenaFlyout
arenaNextEnemy
arenaPlayer
arenaPlayerTransition
battleStyle
bgmVolume
cache
cameras
candyBar
candyUpgradeDisplay
candyUpgradeNotification
charSprite
children
commandCursorMemory
conditionalQueue
currentBattle
damageNumberHandler
damageNumbersMode
data
dexForDevs
disableMenu
eggSkipPreference
enableMoveInfo
enableRetries
enableTouchControls
enableTutorials
enableVibration
eventManager
events
eventTarget
experimentalSprites
expGainsSpeed
expParty
facebook
field
fieldSpritePipeline
fieldUI
fieldVolume
fusionPaletteSwaps
game
gameData
gameMode
gameSpeed
hideIvs
hpBarSpeed
input
inputController
inputMethod
lastEnemyTrainer
lastMysteryEncounter?
lastSavePlayTime
lights
load
lockModifierTiers
make
masterVolume
matter
modifiers
money
moneyFormat
moveAnimations
musicPreference
mysteryEncounterSaveData
offsetGym
partyExpBar
pbTray
pbTrayEnemy
phaseQueue
physics
plugins
pokeballCounts
pokemonInfoContainer
registry
renderer
reroll
rexUI
rngCounter
rngOffset
rngSeedOverride
scale
scaledCanvas
scene
score
seed
sessionPlayTime
sessionSlotId
seVolume
shopCursorTarget
showArenaFlyout
showBgmBar
showLevelUpStats
showMovesetFlyout
showTimeOfDayWidget
skipSeenDialogues
sound
spritePipeline
sys
textures
time
timeOfDayAnimation
trainer
tweens
typeHints
ui
uiContainer
uiInputs
uiTheme
uiVolume
waveCycleOffset
waveSeed
windowType

### Methods

addEnemyModifier
addEnemyPokemon
addFaintedEnemyScore
addFieldSprite
addInfoToggle
addModifier
addMoney
addPlayerPokemon
addPokemonIcon
addPokemonSprite
animateMoneyChanged
appendToPhase
applyModifier
applyModifiers
applyModifiersInternal
applyPartyExp
applyShuffledModifiers
cachedFetch
canTransferHeldItemModifier
clearAllPhases
clearEnemyHeldItemModifiers
clearEnemyModifiers
clearPhaseQueue
clearPhaseQueueSplice
create
executeWithSeedOffset
fadeAndSwitchBgm
fadeOutBgm
findModifier
findModifiers
findPhase
generateEnemyModifiers
generateRandomBiome
getActiveKeys
getBgmLoopPoint
getCachedUrl
getCurrentPhase
getDoubleBattleChance
getEncounterBossSegments
getEnemyField
getEnemyParty
getEnemyPokemon
getField
getInfoToggles
getMaxExpLevel
getModifierBar
getModifiers
getMysteryEncounter
getPlayerField
getPlayerParty
getPlayerPokemon
getPokemonAllowedInBattle
getPokemonById
getSpeciesFormIndex
getStandbyPhase
getWaveMoneyAmount
hasExpSprite
hasModifier
hideAbilityBar
hideEnemyModifierBar
hideFieldOverlay
hideLuckText
hideShopOverlay
initExpSprites
initFinalBossPhaseTwo
initPokemonSprite
initSession
initStarterColors
initVariantData
isBgmPlaying
isMysteryEncounterValidForWave
launchBattle
loadAtlas
loadBgm
loadImage
loadPokemonAtlas
loadPokemonVariantAssets
loadSe
loadSpritesheet
moveBelowOverlay
newArena
newBattle
overridePhase
pauseBgm
playBgm
playSound
playSoundWithoutBgm
populatePhaseQueue
preload
prependToPhase
processInfoButton
pushConditionalPhase
pushPhase
queueAbilityDisplay
queueMessage
randBattleSeedInt
randomSpecies
redirectPokemonMoves
removeModifier
removePartyMemberModifiers
removePokemonFromPlayerParty
reset
resetSeed
resumeBgm
sendTextToBack
setFieldScale
setModifiersVisible
setPhaseQueueSplice
setSeed
shiftPhase
showEnemyModifierBar
showFieldOverlay
showShopOverlay
toggleInvert
triggerPokemonBattleAnim
triggerPokemonFormChange
tryRemovePhase
tryRemoveUnshiftedPhase
tryReplacePhase
trySpreadPokerus
tryTransferHeldItemModifier
unshiftPhase
update
updateAndShowText
updateBiomeWaveText
updateFieldScale
updateGameInfo
updateModifiers
updateMoneyText
updatePartyForModifiers
updateScoreText
updateShopOverlayOpacity
updateSoundVolume
updateUIPositions
validateAchv
validateAchvs
validateVoucher

## Constructors

### constructor

- new default(): default

  #### Returns default

  Overrides SceneBase.constructor

  - Defined in src/battle-scene.ts:394

## Properties

### abilityBar

abilityBar: default

- Defined in src/battle-scene.ts:314

### add

add: GameObjectFactory

The Scene Game Object Factory.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.add

- Defined in node_modules/phaser/types/phaser.d.ts:101257

### anims

anims: AnimationManager

A reference to the global Animation Manager.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.anims

- Defined in node_modules/phaser/types/phaser.d.ts:101208

### arena

arena: Arena

- Defined in src/battle-scene.ts:323

### arenaBg

arenaBg: Sprite

- Defined in src/battle-scene.ts:317

### arenaBgTransition

arenaBgTransition: Sprite

- Defined in src/battle-scene.ts:318

### arenaEnemy

arenaEnemy: ArenaBase

- Defined in src/battle-scene.ts:321

### arenaFlyout

arenaFlyout: ArenaFlyout

- Defined in src/battle-scene.ts:346

### arenaNextEnemy

arenaNextEnemy: ArenaBase

- Defined in src/battle-scene.ts:322

### arenaPlayer

arenaPlayer: ArenaBase

- Defined in src/battle-scene.ts:319

### arenaPlayerTransition

arenaPlayerTransition: ArenaBase

- Defined in src/battle-scene.ts:320

### battleStyle

battleStyle: number = BattleStyle.SWITCH

Determines the selected battle style.

- 0 = 'Switch'
- 1 = 'Set' - The option to switch the active pokemon at the start of a battle will not display.

- Defined in src/battle-scene.ts:283

### bgmVolume

bgmVolume: number = 1

- Defined in src/battle-scene.ts:211

### cache

cache: CacheManager

A reference to the global Cache.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.cache

- Defined in node_modules/phaser/types/phaser.d.ts:101215

### cameras

cameras: CameraManager

The Scene Camera Manager.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.cameras

- Defined in node_modules/phaser/types/phaser.d.ts:101250

### candyBar

candyBar: default

- Defined in src/battle-scene.ts:316

### candyUpgradeDisplay

candyUpgradeDisplay: number = 0

Determines what type of notification is used for Candy Upgrades

- 0 = 'Icon'
- 1 = 'Animation'

- Defined in src/battle-scene.ts:242

### candyUpgradeNotification

candyUpgradeNotification: number = 0

Determines the condition for a notification should be shown for Candy Upgrades

- 0 = 'Off'
- 1 = 'Passives Only'
- 2 = 'On'

- Defined in src/battle-scene.ts:236

### charSprite

charSprite: default

- Defined in src/battle-scene.ts:311

### children

children: DisplayList

The Game Object Display List belonging to this Scene.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.children

- Defined in node_modules/phaser/types/phaser.d.ts:101278

### commandCursorMemory

commandCursorMemory: boolean = false

- Defined in src/battle-scene.ts:219

### conditionalQueue

conditionalQueue: [() => boolean, Phase ][]

- Defined in src/battle-scene.ts:299

### currentBattle

currentBattle: default

- Defined in src/battle-scene.ts:329

### damageNumberHandler

damageNumberHandler: default

- Defined in src/battle-scene.ts:363

### damageNumbersMode

damageNumbersMode: number = 0

- Defined in src/battle-scene.ts:216

### data

data: DataManager

A Scene specific Data Manager Plugin.

See the `registry` property for the global Data Manager.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.data

- Defined in node_modules/phaser/types/phaser.d.ts:101294

### dexForDevs

dexForDevs: boolean = false

- Defined in src/battle-scene.ts:220

### disableMenu

disableMenu: boolean = false

- Defined in src/battle-scene.ts:292

### eggSkipPreference

eggSkipPreference: number = 0

Determines if the egg hatching animation should be skipped

- 0 = Never (never skip animation)
- 1 = Ask (ask to skip animation when hatching 2 or more eggs)
- 2 = Always (automatically skip animation when hatching 2 or more eggs)

- Defined in src/battle-scene.ts:257

### enableMoveInfo

enableMoveInfo: boolean = true

- Defined in src/battle-scene.ts:227

### enableRetries

enableRetries: boolean = false

- Defined in src/battle-scene.ts:228

### enableTouchControls

enableTouchControls: boolean = false

- Defined in src/battle-scene.ts:274

### enableTutorials

enableTutorials: boolean = ...

- Defined in src/battle-scene.ts:226

### enableVibration

enableVibration: boolean = false

- Defined in src/battle-scene.ts:275

### eventManager

eventManager: TimedEventManager

- Defined in src/battle-scene.ts:381

### events

events: EventEmitter

A Scene specific Event Emitter.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.events

- Defined in node_modules/phaser/types/phaser.d.ts:101243

### `Readonly` eventTarget

eventTarget: EventTarget = ...

Allows subscribers to listen for events

Current Events:

- BattleSceneEventType.MOVE_USED MoveUsedEvent
- BattleSceneEventType.TURN_INIT TurnInitEvent
- BattleSceneEventType.TURN_END TurnEndEvent
- BattleSceneEventType.NEW_ARENA `NewArenaEvent`

- Defined in src/battle-scene.ts:392

### experimentalSprites

experimentalSprites: boolean = false

- Defined in src/battle-scene.ts:246

### expGainsSpeed

expGainsSpeed: ExpGainsSpeed = ExpGainsSpeed.DEFAULT

- Defined in src/battle-scene.ts:249

### expParty

expParty: ExpNotification = 0

Defines the experience gain display mode.

#### Remarks

The `expParty` can have several modes:

- `0` - Default: The normal experience gain display, nothing changed.
- `1` - Level Up Notification: Displays the level up in the small frame instead of a message.
- `2` - Skip: No level up frame nor message.

Modes `1` and `2` are still compatible with stats display, level up, new move, etc.

#### Default

    0 - Uses the default normal experience gain display.

- Defined in src/battle-scene.ts:271

### facebook

facebook: FacebookInstantGamesPlugin

The Facebook Instant Games Plugin.

This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.

Inherited from SceneBase.facebook

- Defined in node_modules/phaser/types/phaser.d.ts:101343

### field

field: Container

- Defined in src/battle-scene.ts:309

### fieldSpritePipeline

fieldSpritePipeline: default

- Defined in src/battle-scene.ts:366

### fieldUI

fieldUI: Container

- Defined in src/battle-scene.ts:310

### fieldVolume

fieldVolume: number = 1

- Defined in src/battle-scene.ts:212

### fusionPaletteSwaps

fusionPaletteSwaps: boolean = true

- Defined in src/battle-scene.ts:273

### game

game: Game

A reference to the Phaser.Game instance.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.game

- Defined in node_modules/phaser/types/phaser.d.ts:101201

### gameData

gameData: GameData

- Defined in src/battle-scene.ts:294

### gameMode

gameMode: GameMode

- Defined in src/battle-scene.ts:324

### gameSpeed

gameSpeed: number = 1

- Defined in src/battle-scene.ts:215

### hideIvs

hideIvs: boolean = false

- Defined in src/battle-scene.ts:229

### hpBarSpeed

hpBarSpeed: number = 0

- Defined in src/battle-scene.ts:272

### input

input: InputPlugin

The Scene Input Manager Plugin.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.input

- Defined in node_modules/phaser/types/phaser.d.ts:101301

### inputController

inputController: InputsController

- Defined in src/battle-scene.ts:205

### inputMethod

inputMethod: string

- Defined in src/battle-scene.ts:378

### lastEnemyTrainer

lastEnemyTrainer: null | default

- Defined in src/battle-scene.ts:328

### `Optional` lastMysteryEncounter

lastMysteryEncounter?: default

If the previous wave was a MysteryEncounter, tracks the object with this variable. Mostly used for visual object cleanup

- Defined in src/battle-scene.ts:337

### lastSavePlayTime

lastSavePlayTime: null | number = null

- Defined in src/battle-scene.ts:209

### lights

lights: LightsManager

The Scene Lights Manager Plugin.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.lights

- Defined in node_modules/phaser/types/phaser.d.ts:101285

### load

load: LoaderPlugin

The Scene Loader Plugin.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.load

- Defined in node_modules/phaser/types/phaser.d.ts:101308

### lockModifierTiers

lockModifierTiers: boolean

- Defined in src/battle-scene.ts:326

### make

make: GameObjectCreator

The Scene Game Object Creator.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.make

- Defined in node_modules/phaser/types/phaser.d.ts:101264

### masterVolume

masterVolume: number = 0.5

- Defined in src/battle-scene.ts:210

### matter

matter: MatterPhysics

The Scene Matter Physics Plugin.

This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.

Inherited from SceneBase.matter

- Defined in node_modules/phaser/types/phaser.d.ts:101336

### modifiers

modifiers: PersistentModifier []

- Defined in src/battle-scene.ts:353

### money

money: number

- Defined in src/battle-scene.ts:331

### moneyFormat

moneyFormat: MoneyFormat = MoneyFormat.NORMAL

- Defined in src/battle-scene.ts:243

### moveAnimations

moveAnimations: boolean = true

- Defined in src/battle-scene.ts:248

### musicPreference

musicPreference: number = MusicPreference.ALLGENS

- Defined in src/battle-scene.ts:247

### mysteryEncounterSaveData

mysteryEncounterSaveData: MysteryEncounterSaveData = ...

Session save data that pertains to Mystery Encounters

- Defined in src/battle-scene.ts:335

### offsetGym

offsetGym: boolean

- Defined in src/battle-scene.ts:361

### partyExpBar

partyExpBar: default

- Defined in src/battle-scene.ts:315

### pbTray

pbTray: default

- Defined in src/battle-scene.ts:312

### pbTrayEnemy

pbTrayEnemy: default

- Defined in src/battle-scene.ts:313

### phaseQueue

phaseQueue: Phase []

PhaseQueue: dequeue/remove the first element to get the next phase

- Defined in src/battle-scene.ts:298

### physics

physics: ArcadePhysics

The Scene Arcade Physics Plugin.

This property will only be available if defined in the Scene Injection Map, the plugin is installed and configured.

Inherited from SceneBase.physics

- Defined in node_modules/phaser/types/phaser.d.ts:101329

### plugins

plugins: PluginManager

A reference to the global Plugin Manager.

The Plugin Manager is a global system that allows plugins to register themselves with it, and can then install those plugins into Scenes as required.

Inherited from SceneBase.plugins

- Defined in node_modules/phaser/types/phaser.d.ts:101358

### pokeballCounts

pokeballCounts: PokeballCounts

- Defined in src/battle-scene.ts:330

### pokemonInfoContainer

pokemonInfoContainer: default

- Defined in src/battle-scene.ts:332

### registry

registry: DataManager

A reference to the global Data Manager.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.registry

- Defined in node_modules/phaser/types/phaser.d.ts:101222

### renderer

renderer: CanvasRenderer | WebGLRenderer

A reference to the renderer instance Phaser is using, either Canvas Renderer or WebGL Renderer.

Inherited from SceneBase.renderer

- Defined in node_modules/phaser/types/phaser.d.ts:101363

### reroll

reroll: boolean = false

- Defined in src/battle-scene.ts:217

### rexUI

rexUI: UIPlugin

- Defined in src/battle-scene.ts:204

### rngCounter

rngCounter: number = 0

- Defined in src/battle-scene.ts:374

### rngOffset

rngOffset: number = 0

- Defined in src/battle-scene.ts:376

### rngSeedOverride

rngSeedOverride: string = ""

- Defined in src/battle-scene.ts:375

### scale

scale: ScaleManager

A reference to the global Scale Manager.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.scale

- Defined in node_modules/phaser/types/phaser.d.ts:101350

### `Readonly` scaledCanvas

scaledCanvas: { height: number; width: number } = ...

Since everything is scaled up by 6 by default using the game.canvas is annoying Until such point that we use the canvas normally, this will be easier than having to divide every width and heigh by 6 to position and scale the ui

#### Default Value

width: `320` height: `180`

Inherited from SceneBase.scaledCanvas

- Defined in src/scene-base.ts:13

### scene

scene: ScenePlugin

A reference to the Scene Manager Plugin.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.scene

- Defined in node_modules/phaser/types/phaser.d.ts:101271

### score

score: number

- Defined in src/battle-scene.ts:325

### seed

seed: string

- Defined in src/battle-scene.ts:358

### sessionPlayTime

sessionPlayTime: null | number = null

- Defined in src/battle-scene.ts:208

### sessionSlotId

sessionSlotId: number

- Defined in src/battle-scene.ts:295

### seVolume

seVolume: number = 1

- Defined in src/battle-scene.ts:213

### shopCursorTarget

shopCursorTarget: number = ShopCursorTarget.REWARDS

- Defined in src/battle-scene.ts:218

### showArenaFlyout

showArenaFlyout: boolean = true

- Defined in src/battle-scene.ts:222

### showBgmBar

showBgmBar: boolean = true

- Defined in src/battle-scene.ts:276

### showLevelUpStats

showLevelUpStats: boolean = true

- Defined in src/battle-scene.ts:225

### showMovesetFlyout

showMovesetFlyout: boolean = true

- Defined in src/battle-scene.ts:221

### showTimeOfDayWidget

showTimeOfDayWidget: boolean = true

- Defined in src/battle-scene.ts:223

### skipSeenDialogues

skipSeenDialogues: boolean = false

- Defined in src/battle-scene.ts:250

### sound

sound: NoAudioSoundManager | HTML5AudioSoundManager | WebAudioSoundManager

A reference to the Sound Manager.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.sound

- Defined in node_modules/phaser/types/phaser.d.ts:101229

### spritePipeline

spritePipeline: default

- Defined in src/battle-scene.ts:367

### sys

sys: Systems

The Scene Systems. You must never overwrite this property, or all hell will break lose.

Inherited from SceneBase.sys

- Defined in node_modules/phaser/types/phaser.d.ts:101194

### textures

textures: TextureManager

A reference to the Texture Manager.

This property will only be available if defined in the Scene Injection Map.

Inherited from SceneBase.textures

- Defined in node_modules/phaser/types/phaser.d.ts:101236

### time

time: Clock

The Scene Time and Clock Plugin.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.time

- Defined in node_modules/phaser/types/phaser.d.ts:101315

### timeOfDayAnimation

timeOfDayAnimation: EaseType = EaseType.NONE

- Defined in src/battle-scene.ts:224

### trainer

trainer: Sprite

- Defined in src/battle-scene.ts:327

### tweens

tweens: TweenManager

The Scene Tween Manager Plugin.

This property will only be available if defined in the Scene Injection Map and the plugin is installed.

Inherited from SceneBase.tweens

- Defined in node_modules/phaser/types/phaser.d.ts:101322

### typeHints

typeHints: boolean = false

Defines whether or not to show type effectiveness hints

- true: No hints
- false: Show hints for moves

- Defined in src/battle-scene.ts:290

### ui

ui: default

- Defined in src/battle-scene.ts:356

### uiContainer

uiContainer: Container

- Defined in src/battle-scene.ts:355

### uiInputs

uiInputs: UiInputs

- Defined in src/battle-scene.ts:206

### uiTheme

uiTheme: UiTheme = UiTheme.DEFAULT

- Defined in src/battle-scene.ts:244

### uiVolume

uiVolume: number = 1

- Defined in src/battle-scene.ts:214

### waveCycleOffset

waveCycleOffset: number

- Defined in src/battle-scene.ts:360

### waveSeed

waveSeed: string

- Defined in src/battle-scene.ts:359

### windowType

windowType: number = 0

- Defined in src/battle-scene.ts:245

## Methods

### addEnemyModifier

- addEnemyModifier(
  modifier: PersistentModifier ,
  ignoreUpdate?: boolean,
  instant?: boolean,
  ): Promise<void>

  #### Parameters

  - modifier: PersistentModifier
  - `Optional` ignoreUpdate: boolean
  - `Optional` instant: boolean

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:3069

### addEnemyPokemon

- addEnemyPokemon(
  species: default ,
  level: number,
  trainerSlot: TrainerSlot ,
  boss?: boolean,
  shinyLock?: boolean,
  dataSource?: default ,
  postProcess?: (enemyPokemon: EnemyPokemon ) => void,
  ): EnemyPokemon

  #### Parameters

  - species: default
  - level: number
  - trainerSlot: TrainerSlot
  - boss: boolean = false
  - shinyLock: boolean = false
  - `Optional` dataSource: default
  - `Optional` postProcess: (enemyPokemon: EnemyPokemon ) => void

  #### Returns EnemyPokemon

  - Defined in src/battle-scene.ts:1046

### addFaintedEnemyScore

- addFaintedEnemyScore(enemy: EnemyPokemon ): void

  #### Parameters

  - enemy: EnemyPokemon

  #### Returns void

  - Defined in src/battle-scene.ts:2182

### addFieldSprite

- addFieldSprite(
  x: number,
  y: number,
  texture: string | Texture,
  frame?: string | number,
  terrainColorRatio?: number,
  ): Sprite

  #### Parameters

  - x: number
  - y: number
  - texture: string | Texture
  - `Optional` frame: string | number
  - terrainColorRatio: number = 0

  #### Returns Sprite

  - Defined in src/battle-scene.ts:1945

### addInfoToggle

- addInfoToggle(infoToggle: InfoToggle ): void

  #### Parameters

  - infoToggle: InfoToggle

  #### Returns void

  - Defined in src/battle-scene.ts:1000

### addModifier

- addModifier(
  modifier: null | Modifier ,
  ignoreUpdate?: boolean,
  playSound?: boolean,
  virtual?: boolean,
  instant?: boolean,
  cost?: number,
  ): boolean

  #### Parameters

  - modifier: null | Modifier
  - `Optional` ignoreUpdate: boolean
  - `Optional` playSound: boolean
  - `Optional` virtual: boolean
  - `Optional` instant: boolean
  - `Optional` cost: number

  #### Returns boolean

  - Defined in src/battle-scene.ts:2980

### addMoney

- addMoney(amount: number): void

  #### Parameters

  - amount: number

  #### Returns void

  - Defined in src/battle-scene.ts:2964

### addPlayerPokemon

- addPlayerPokemon(
  species: default ,
  level: number,
  abilityIndex?: number,
  formIndex?: number,
  gender?: Gender ,
  shiny?: boolean,
  variant?: Variant ,
  ivs?: number[],
  nature?: Nature ,
  dataSource?: default | default ,
  postProcess?: (playerPokemon: PlayerPokemon ) => void,
  ): PlayerPokemon

  #### Parameters

  - species: default
  - level: number
  - `Optional` abilityIndex: number
  - `Optional` formIndex: number
  - `Optional` gender: Gender
  - `Optional` shiny: boolean
  - `Optional` variant: Variant
  - `Optional` ivs: number[]
  - `Optional` nature: Nature
  - `Optional` dataSource: default | default
  - `Optional` postProcess: (playerPokemon: PlayerPokemon ) => void

  #### Returns PlayerPokemon

  - Defined in src/battle-scene.ts:1014

### addPokemonIcon

- addPokemonIcon(
  pokemon: default ,
  x: number,
  y: number,
  originX?: number,
  originY?: number,
  ignoreOverride?: boolean,
  ): Container

  #### Parameters

  - pokemon: default
  - x: number
  - y: number
  - originX: number = 0.5
  - originY: number = 0.5
  - ignoreOverride: boolean = false

  #### Returns Container

  - Defined in src/battle-scene.ts:1116

### addPokemonSprite

- addPokemonSprite(
  pokemon: default ,
  x: number,
  y: number,
  texture: string | Texture,
  frame?: string | number,
  hasShadow?: boolean,
  ignoreOverride?: boolean,
  ): Sprite

  #### Parameters

  - pokemon: default
  - x: number
  - y: number
  - texture: string | Texture
  - `Optional` frame: string | number
  - hasShadow: boolean = false
  - ignoreOverride: boolean = false

  #### Returns Sprite

  - Defined in src/battle-scene.ts:1961

### animateMoneyChanged

- animateMoneyChanged(positiveChange: boolean): void

  #### Parameters

  - positiveChange: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:2087

### appendToPhase

- appendToPhase(phase: Phase | Phase [], targetPhase: Constructor < Phase >): boolean

  Tries to add the input phase(s) to index after target phase in the `phaseQueue`, else simply calls `()`

  #### Parameters

  - phase: Phase | Phase []

    `Phase` the phase(s) to be added

  - targetPhase: Constructor < Phase >

    `Phase` the type of phase to search for in `phaseQueue`

  #### Returns boolean

  `true` if a `targetPhase` was found to append to

  - Defined in src/battle-scene.ts:2894

### applyModifier

- applyModifier< T extends PersistentModifier >(
  modifierType: Constructor < T >,
  player?: boolean,
  ...args: Parameters< T ["apply"]>,
  ): null | T

  Apply the first modifier that matches `modifierType`

  #### Type Parameters

  - T extends PersistentModifier

  #### Parameters

  - modifierType: Constructor < T >

    The type of modifier to apply; must extend `PersistentModifier`

  - player: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  - ...args: Parameters< T ["apply"]>

  #### Returns null | T

  the first modifier that matches `modifierType` and was applied; return `null` if none matched

  - Defined in src/battle-scene.ts:3508

### applyModifiers

- applyModifiers< T extends PersistentModifier >(
  modifierType: Constructor < T >,
  player?: boolean,
  ...args: Parameters< T ["apply"]>,
  ): T []

  Apply all modifiers that match `modifierType`

  #### Type Parameters

  - T extends PersistentModifier

  #### Parameters

  - modifierType: Constructor < T >

    The type of modifier to apply; must extend `PersistentModifier`

  - player: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  - ...args: Parameters< T ["apply"]>

  #### Returns T []

  the list of all modifiers that matched `modifierType` and were applied.

  - Defined in src/battle-scene.ts:3473

### applyModifiersInternal

- applyModifiersInternal< T extends PersistentModifier >(
  modifiers: T [],
  player: boolean,
  args: Parameters< T ["apply"]>,
  ): T []

  Helper function to apply all passed modifiers

  #### Type Parameters

  - T extends PersistentModifier

  #### Parameters

  - modifiers: T []
  - player: boolean
  - args: Parameters< T ["apply"]>

  #### Returns T []

  - Defined in src/battle-scene.ts:3485

### applyPartyExp

- applyPartyExp(
  expValue: number,
  pokemonDefeated: boolean,
  useWaveIndexMultiplier?: boolean,
  pokemonParticipantIds?: Set<number>,
  ): void

  Updates Exp and level values for Player's party, adding new level up phases as required

  #### Parameters

  - expValue: number

    raw value of exp to split among participants, OR the base multiplier to use with waveIndex

  - pokemonDefeated: boolean

    If true, will increment Macho Brace stacks and give the party Pokemon friendship increases

  - `Optional` useWaveIndexMultiplier: boolean

    Default false. If true, will multiply expValue by a scaling waveIndex multiplier. Not needed if expValue is already scaled by level/wave

  - `Optional` pokemonParticipantIds: Set<number>

    Participants. If none are defined, no exp will be given. To spread evenly among the party, should pass all ids of party members.

  #### Returns void

  - Defined in src/battle-scene.ts:3720

### applyShuffledModifiers

- applyShuffledModifiers< T extends PersistentModifier >(
  modifierType: Constructor < T >,
  player?: boolean,
  ...args: Parameters< T ["apply"]>,
  ): T []

  Apply all modifiers that match `modifierType` in a random order

  #### Type Parameters

  - T extends PersistentModifier

  #### Parameters

  - modifierType: Constructor < T >

    The type of modifier to apply; must extend `PersistentModifier`

  - player: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  - ...args: Parameters< T ["apply"]>

  #### Returns T []

  the list of all modifiers that matched `modifierType` and were applied.

  - Defined in src/battle-scene.ts:3441

### cachedFetch

- cachedFetch(url: string, init?: RequestInit): Promise<Response>

  #### Parameters

  - url: string
  - `Optional` init: RequestInit

  #### Returns Promise<Response>

  - Defined in src/battle-scene.ts:835

### canTransferHeldItemModifier

- canTransferHeldItemModifier(
  itemModifier: PokemonHeldItemModifier ,
  target: default ,
  transferQuantity?: number,
  ): boolean

  #### Parameters

  - itemModifier: PokemonHeldItemModifier
  - target: default
  - transferQuantity: number = 1

  #### Returns boolean

  - Defined in src/battle-scene.ts:3182

### clearAllPhases

- clearAllPhases(): void

  Clears all phase-related stuff, including all phase queues, the current and standby phases, and a splice index

  #### Returns void

  - Defined in src/battle-scene.ts:2738

### clearEnemyHeldItemModifiers

- clearEnemyHeldItemModifiers(pokemon?: default ): void

  Removes all modifiers from enemy pokemon of `PokemonHeldItemModifier` type

  #### Parameters

  - `Optional` pokemon: default

    If specified, only removes held items from that `Pokemon`

  #### Returns void

  - Defined in src/battle-scene.ts:3317

### clearEnemyModifiers

- clearEnemyModifiers(): void

  Removes all modifiers from enemy pokemon of `PersistentModifier` type

  #### Returns void

  - Defined in src/battle-scene.ts:3304

### clearPhaseQueue

- clearPhaseQueue(): void

  Clears the phaseQueue

  #### Returns void

  - Defined in src/battle-scene.ts:2731

### clearPhaseQueueSplice

- clearPhaseQueueSplice(): void

  Resets phaseQueuePrependSpliceIndex to -1, implies that calls to unshiftPhase will insert at end of phaseQueuePrepend

  #### Returns void

  - Defined in src/battle-scene.ts:2757

### create

- create(): void

  #### Returns void

  - Defined in src/battle-scene.ts:473

### executeWithSeedOffset

- executeWithSeedOffset(
  func: Function,
  offset: number,
  seedOverride?: string,
  ): void

  #### Parameters

  - func: Function
  - offset: number
  - `Optional` seedOverride: string

  #### Returns void

  - Defined in src/battle-scene.ts:1921

### fadeAndSwitchBgm

- fadeAndSwitchBgm(newBgmKey: string, destroy?: boolean, delay?: number): void

  Fades out current track for `delay` ms, then fades in new track.

  #### Parameters

  - newBgmKey: string
  - destroy: boolean = false
  - delay: number = 2000

  #### Returns void

  - Defined in src/battle-scene.ts:2389

### fadeOutBgm

- fadeOutBgm(duration?: number, destroy?: boolean): boolean

  #### Parameters

  - duration: number = 500
  - destroy: boolean = true

  #### Returns boolean

  - Defined in src/battle-scene.ts:2370

### findModifier

- findModifier(
  modifierFilter: ModifierPredicate ,
  player?: boolean,
  ): undefined | PersistentModifier

  Find the first modifier that pass the `modifierFilter` function

  #### Parameters

  - modifierFilter: ModifierPredicate

    The function used to filter a target's modifiers

  - player: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  #### Returns undefined | PersistentModifier

  the first modifier that passed the `modifierFilter` function; `undefined` if none passed

  - Defined in src/battle-scene.ts:3430

### findModifiers

- findModifiers(
  modifierFilter: ModifierPredicate ,
  isPlayer?: boolean,
  ): PersistentModifier []

  Get all of the modifiers that pass the `modifierFilter` function

  #### Parameters

  - modifierFilter: ModifierPredicate

    The function used to filter a target's modifiers

  - isPlayer: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  #### Returns PersistentModifier []

  the list of all modifiers that passed the `modifierFilter` function

  - Defined in src/battle-scene.ts:3420

### findPhase

- findPhase< P extends Phase = Phase >(
  phaseFilter: (phase: P ) => boolean,
  ): undefined | P

  Find a specific `Phase` in the phase queue.

  #### Type Parameters

  - P extends Phase = Phase

  #### Parameters

  - phaseFilter: (phase: P ) => boolean

    filter function to use to find the wanted phase

  #### Returns undefined | P

  the found phase or undefined if none found

  - Defined in src/battle-scene.ts:2833

### generateEnemyModifiers

- generateEnemyModifiers(heldModifiersConfigs?: default [][]): Promise<void>

  #### Parameters

  - `Optional` heldModifiersConfigs: default [][]

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:3231

### generateRandomBiome

- generateRandomBiome(waveIndex: number): Biome

  #### Parameters

  - waveIndex: number

  #### Returns Biome

  - Defined in src/battle-scene.ts:2239

### getActiveKeys

- getActiveKeys(): string[]

  This function retrieves the sprite and audio keys for active Pokemon. Active Pokemon include both enemy and player Pokemon of the current wave. Note: Questions on garbage collection go to

  #### Returns string[]

  a string array of active sprite and audio keys that should not be deleted

  #### Frutescens

  - Defined in src/battle-scene.ts:3658

### getBgmLoopPoint

- getBgmLoopPoint(bgmName: string): number

  The loop point of any given battle, mystery encounter, or title track, read as seconds and milliseconds.

  #### Parameters

  - bgmName: string

  #### Returns number

  - Defined in src/battle-scene.ts:2455

### getCachedUrl

- getCachedUrl(url: string): string

  #### Parameters

  - url: string

  #### Returns string

  Inherited from SceneBase.getCachedUrl

  - Defined in src/scene-base.ts:18

### getCurrentPhase

- getCurrentPhase(): null | Phase

  #### Returns null | Phase

  - Defined in src/battle-scene.ts:2685

### getDoubleBattleChance

- getDoubleBattleChance(
  newWaveIndex: number,
  playerField: PlayerPokemon [],
  ): number

  #### Parameters

  - newWaveIndex: number
  - playerField: PlayerPokemon []

  #### Returns number

  - Defined in src/battle-scene.ts:1366

### getEncounterBossSegments

- getEncounterBossSegments(
  waveIndex: number,
  level: number,
  species?: default ,
  forceBoss?: boolean,
  ): number

  #### Parameters

  - waveIndex: number
  - level: number
  - `Optional` species: default
  - forceBoss: boolean = false

  #### Returns number

  - Defined in src/battle-scene.ts:1841

### getEnemyField

- getEnemyField(): EnemyPokemon []

  Returns an array of EnemyPokemon of length 1 or 2 depending on if in a double battle or not. Does not actually check if the pokemon are on the field or not.

  #### Returns EnemyPokemon []

  array of `EnemyPokemon`

  - Defined in src/battle-scene.ts:943

### getEnemyParty

- getEnemyParty(): EnemyPokemon []

  #### Returns EnemyPokemon []

  - Defined in src/battle-scene.ts:923

### getEnemyPokemon

- getEnemyPokemon(includeSwitching?: boolean): undefined | EnemyPokemon

  #### Parameters

  - includeSwitching: boolean = true

    Whether a pokemon that is currently switching out is valid, default `true`

  #### Returns undefined | EnemyPokemon

  The first `EnemyPokemon` that is `on the field` and `is active` (aka `is allowed in battle`), or `undefined` if there are no valid pokemon

  - Defined in src/battle-scene.ts:934

### getField

- getField(activeOnly?: boolean): default []

  Returns an array of Pokemon on both sides of the battle - player first, then enemy. Does not actually check if the pokemon are on the field or not, and always has length 4 regardless of battle type.

  #### Parameters

  - activeOnly: boolean = false

    Whether to consider only active pokemon

  #### Returns default []

  array of `Pokemon`

  - Defined in src/battle-scene.ts:954

### getInfoToggles

- getInfoToggles(activeOnly?: boolean): InfoToggle []

  #### Parameters

  - activeOnly: boolean = false

  #### Returns InfoToggle []

  - Defined in src/battle-scene.ts:1005

### getMaxExpLevel

- getMaxExpLevel(ignoreLevelCap?: boolean): number

  #### Parameters

  - ignoreLevelCap: boolean = false

  #### Returns number

  - Defined in src/battle-scene.ts:2196

### getModifierBar

- getModifierBar(isEnemy?: boolean): ModifierBar

  Returns the ModifierBar of this scene, which is declared private and therefore not accessible elsewhere

  #### Parameters

  - `Optional` isEnemy: boolean

    Whether to return the enemy's modifier bar

  #### Returns ModifierBar

  - Defined in src/battle-scene.ts:995

### getModifiers

- getModifiers< T extends PersistentModifier >(
  modifierType: Constructor < T >,
  player?: boolean,
  ): T []

  Get all of the modifiers that match `modifierType`

  #### Type Parameters

  - T extends PersistentModifier

  #### Parameters

  - modifierType: Constructor < T >

    The type of modifier to apply; must extend `PersistentModifier`

  - player: boolean = true

    Whether to search the player (`true`) or the enemy (`false`); Defaults to `true`

  #### Returns T []

  the list of all modifiers that matched `modifierType`.

  - Defined in src/battle-scene.ts:3410

### getMysteryEncounter

- getMysteryEncounter(
  encounterType?: MysteryEncounterType ,
  canBypass?: boolean,
  ): default

  Loads or generates a mystery encounter

  #### Parameters

  - `Optional` encounterType: MysteryEncounterType

    used to load session encounter when restarting game, etc.

  - `Optional` canBypass: boolean

    optional boolean to indicate that the request is coming from a function that needs to access a Mystery Encounter outside of gameplay requirements

  #### Returns default

  - Defined in src/battle-scene.ts:3905

### getPlayerField

- getPlayerField(): PlayerPokemon []

  Returns an array of PlayerPokemon of length 1 or 2 depending on if in a double battle or not. Does not actually check if the pokemon are on the field or not.

  #### Returns PlayerPokemon []

  array of `PlayerPokemon`

  - Defined in src/battle-scene.ts:918

### getPlayerParty

- getPlayerParty(): PlayerPokemon []

  #### Returns PlayerPokemon []

  - Defined in src/battle-scene.ts:890

### getPlayerPokemon

- getPlayerPokemon(includeSwitching?: boolean): undefined | PlayerPokemon

  #### Parameters

  - includeSwitching: boolean = true

    Whether a pokemon that is currently switching out is valid, default `true`

  #### Returns undefined | PlayerPokemon

  The first `PlayerPokemon` that is `on the field` and `is active` (aka `is allowed in battle`), or `undefined` if there are no valid pokemon

  - Defined in src/battle-scene.ts:909

### getPokemonAllowedInBattle

- getPokemonAllowedInBattle(): PlayerPokemon []

  #### Returns PlayerPokemon []

  An array of `PlayerPokemon` filtered from the player's party that are `allowed in battle`.

  - Defined in src/battle-scene.ts:898

### getPokemonById

- getPokemonById(pokemonId: number): null | default

  #### Parameters

  - pokemonId: number

  #### Returns null | default

  - Defined in src/battle-scene.ts:1009

### getSpeciesFormIndex

- getSpeciesFormIndex(
  species: default ,
  gender?: Gender ,
  nature?: Nature ,
  ignoreArena?: boolean,
  ): number

  #### Parameters

  - species: default
  - `Optional` gender: Gender
  - `Optional` nature: Nature
  - `Optional` ignoreArena: boolean

  #### Returns number

  - Defined in src/battle-scene.ts:1650

### getStandbyPhase

- getStandbyPhase(): null | Phase

  #### Returns null | Phase

  - Defined in src/battle-scene.ts:2689

### getWaveMoneyAmount

- getWaveMoneyAmount(moneyMultiplier: number): number

  #### Parameters

  - moneyMultiplier: number

  #### Returns number

  - Defined in src/battle-scene.ts:2971

### hasExpSprite

- hasExpSprite(key: string): boolean

  #### Parameters

  - key: string

  #### Returns boolean

  - Defined in src/battle-scene.ts:865

### hasModifier

- hasModifier(modifier: PersistentModifier , enemy?: boolean): boolean

  #### Parameters

  - modifier: PersistentModifier
  - enemy: boolean = false

  #### Returns boolean

  - Defined in src/battle-scene.ts:3374

### hideAbilityBar

- hideAbilityBar(): void

  Hides the ability bar if it is currently visible

  #### Returns void

  - Defined in src/battle-scene.ts:2947

### hideEnemyModifierBar

- hideEnemyModifierBar(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2061

### hideFieldOverlay

- hideFieldOverlay(duration: number): Promise<void>

  #### Parameters

  - duration: number

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:2011

### hideLuckText

- hideLuckText(duration: number): void

  #### Parameters

  - duration: number

  #### Returns void

  - Defined in src/battle-scene.ts:2137

### hideShopOverlay

- hideShopOverlay(duration: number): Promise<void>

  #### Parameters

  - duration: number

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:2044

### initExpSprites

- initExpSprites(): Promise<void>

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:785

### initFinalBossPhaseTwo

- initFinalBossPhaseTwo(pokemon: default ): void

  Initialized the 2nd phase of the final boss (e.g. form-change for Eternatus)

  #### Parameters

  - pokemon: default

    The (enemy) pokemon

  #### Returns void

  - Defined in src/battle-scene.ts:3679

### initPokemonSprite

- initPokemonSprite(
  sprite: Sprite,
  pokemon?: default ,
  hasShadow?: boolean,
  ignoreOverride?: boolean,
  ): Sprite

  #### Parameters

  - sprite: Sprite
  - `Optional` pokemon: default
  - hasShadow: boolean = false
  - ignoreOverride: boolean = false

  #### Returns Sprite

  - Defined in src/battle-scene.ts:1975

### initSession

- initSession(): void

  #### Returns void

  - Defined in src/battle-scene.ts:752

### initStarterColors

- initStarterColors(): Promise<void>

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:846

### initVariantData

- initVariantData(): Promise<void>

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:799

### isBgmPlaying

- isBgmPlaying(): boolean

  #### Returns boolean

  - Defined in src/battle-scene.ts:2264

### isMysteryEncounterValidForWave

- isMysteryEncounterValidForWave(
  battleType: BattleType ,
  waveIndex: number,
  ): boolean

  Returns if a wave COULD spawn a `MysteryEncounter`. Even if returns `true`, does not guarantee that a wave will actually be a ME. That check is made in BattleScene.isWaveMysteryEncounter instead.

  #### Parameters

  - battleType: BattleType
  - waveIndex: number

  #### Returns boolean

  - Defined in src/battle-scene.ts:3837

### launchBattle

- launchBattle(): void

  #### Returns void

  - Defined in src/battle-scene.ts:498

### loadAtlas

- loadAtlas(key: string, folder: string, filenameRoot?: string): void

  #### Parameters

  - key: string
  - folder: string
  - `Optional` filenameRoot: string

  #### Returns void

  Inherited from SceneBase.loadAtlas

  - Defined in src/scene-base.ts:59

### loadBgm

- loadBgm(key: string, filename?: string): void

  #### Parameters

  - key: string
  - `Optional` filename: string

  #### Returns void

  Inherited from SceneBase.loadBgm

  - Defined in src/scene-base.ts:99

### loadImage

- loadImage(key: string, folder: string, filename?: string): void

  #### Parameters

  - key: string
  - folder: string
  - `Optional` filename: string

  #### Returns void

  Inherited from SceneBase.loadImage

  - Defined in src/scene-base.ts:29

### loadPokemonAtlas

- loadPokemonAtlas(key: string, atlasPath: string, experimental?: boolean): void

  #### Parameters

  - key: string
  - atlasPath: string
  - `Optional` experimental: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:406

### loadPokemonVariantAssets

- loadPokemonVariantAssets(
  spriteKey: string,
  fileRoot: string,
  variant?: Variant ,
  ): Promise<void>

  Load the variant assets for the given sprite and stores them in `variantColorCache`

  #### Parameters

  - spriteKey: string
  - fileRoot: string
  - `Optional` variant: Variant

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:427

### loadSe

- loadSe(key: string, folder?: string, filenames?: string | string[]): void

  #### Parameters

  - key: string
  - `Optional` folder: string
  - `Optional` filenames: string | string[]

  #### Returns void

  Inherited from SceneBase.loadSe

  - Defined in src/scene-base.ts:82

### loadSpritesheet

- loadSpritesheet(
  key: string,
  folder: string,
  size: number,
  filename?: string,
  ): void

  #### Parameters

  - key: string
  - folder: string
  - size: number
  - `Optional` filename: string

  #### Returns void

  Inherited from SceneBase.loadSpritesheet

  - Defined in src/scene-base.ts:41

### moveBelowOverlay

- moveBelowOverlay< T extends GameObject>(gameObject: T ): void

  #### Type Parameters

  - T extends GameObject

  #### Parameters

  - gameObject: T

  #### Returns void

  - Defined in src/battle-scene.ts:1992

### newArena

- newArena(biome: Biome , playerFaints?: number): Arena

  #### Parameters

  - biome: Biome
  - `Optional` playerFaints: number

  #### Returns Arena

  - Defined in src/battle-scene.ts:1599

### newBattle

- newBattle(
  waveIndex?: number,
  battleType?: BattleType ,
  trainerData?: default ,
  double?: boolean,
  mysteryEncounterType?: MysteryEncounterType ,
  ): null | default

  #### Parameters

  - `Optional` waveIndex: number
  - `Optional` battleType: BattleType
  - `Optional` trainerData: default
  - `Optional` double: boolean
  - `Optional` mysteryEncounterType: MysteryEncounterType

  #### Returns null | default

  - Defined in src/battle-scene.ts:1376

### overridePhase

- overridePhase(phase: Phase ): boolean

  #### Parameters

  - phase: Phase

  #### Returns boolean

  - Defined in src/battle-scene.ts:2814

### pauseBgm

- pauseBgm(): boolean

  #### Returns boolean

  - Defined in src/battle-scene.ts:2329

### playBgm

- playBgm(bgmName?: string, fadeOut?: boolean): void

  #### Parameters

  - `Optional` bgmName: string
  - `Optional` fadeOut: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:2268

### playSound

- playSound(sound: string | AnySound , config?: object): AnySound

  #### Parameters

  - sound: string | AnySound
  - `Optional` config: object

  #### Returns AnySound

  - Defined in src/battle-scene.ts:2396

### playSoundWithoutBgm

- playSoundWithoutBgm(soundName: string, pauseDuration?: number): AnySound

  #### Parameters

  - soundName: string
  - `Optional` pauseDuration: number

  #### Returns AnySound

  - Defined in src/battle-scene.ts:2437

### populatePhaseQueue

- populatePhaseQueue(): void

  Moves everything from nextCommandPhaseQueue to phaseQueue (keeping order)

  #### Returns void

  - Defined in src/battle-scene.ts:2956

### preload

- preload(): Promise<void>

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:453

### prependToPhase

- prependToPhase(phase: Phase | Phase [], targetPhase: Constructor < Phase >): boolean

  Tries to add the input phase to index before target phase in the phaseQueue, else simply calls unshiftPhase()

  #### Parameters

  - phase: Phase | Phase []

    `Phase` the phase to be added

  - targetPhase: Constructor < Phase >

    `Phase` the type of phase to search for in phaseQueue

  #### Returns boolean

  boolean if a targetPhase was found and added

  - Defined in src/battle-scene.ts:2874

### processInfoButton

- processInfoButton(pressed: boolean): void

  #### Parameters

  - pressed: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:1995

### pushConditionalPhase

- pushConditionalPhase(phase: Phase , condition: () => boolean): void

  Adds a phase to the conditional queue and ensures it is executed only when the specified condition is met.

  This method allows deferring the execution of a phase until certain conditions are met, which is useful for handling situations like abilities and entry hazards that depend on specific game states.

  #### Parameters

  - phase: Phase

    The phase to be added to the conditional queue.

  - condition: () => boolean

    A function that returns a boolean indicating whether the phase should be executed.

  #### Returns void

  - Defined in src/battle-scene.ts:2703

### pushPhase

- pushPhase(phase: Phase , defer?: boolean): void

  Adds a phase to nextCommandPhaseQueue, as long as boolean passed in is false

  #### Parameters

  - phase: Phase

    `Phase` the phase to add

  - defer: boolean = false

    boolean on which queue to add to, defaults to false, and adds to phaseQueue

  #### Returns void

  - Defined in src/battle-scene.ts:2712

### queueAbilityDisplay

- queueAbilityDisplay(pokemon: default , passive: boolean, show: boolean): void

  Queues an ability bar flyout phase

  #### Parameters

  - pokemon: default

    The pokemon who has the ability

  - passive: boolean

    Whether the ability is a passive

  - show: boolean

    Whether to show or hide the bar

  #### Returns void

  - Defined in src/battle-scene.ts:2939

### queueMessage

- queueMessage(
  message: string,
  callbackDelay?: null | number,
  prompt?: null | boolean,
  promptDelay?: null | number,
  defer?: null | boolean,
  ): void

  Adds a MessagePhase, either to PhaseQueuePrepend or nextCommandPhaseQueue

  #### Parameters

  - message: string

    string for MessagePhase

  - `Optional` callbackDelay: null | number

    optional param for MessagePhase constructor

  - `Optional` prompt: null | boolean

    optional param for MessagePhase constructor

  - `Optional` promptDelay: null | number

    optional param for MessagePhase constructor

  - `Optional` defer: null | boolean

    boolean for which queue to add it to, false -> add to PhaseQueuePrepend, true -> nextCommandPhaseQueue

  #### Returns void

  - Defined in src/battle-scene.ts:2916

### randBattleSeedInt

- randBattleSeedInt(range: number, min?: number): number

  Generates a random number using the current battle's seed

  This calls `Battle.randSeedInt`(`range`, `min`) in `src/battle.ts` which calls `randSeedInt`(`range`, `min`) in `src/utils.ts`

  #### Parameters

  - range: number

    How large of a range of random numbers to choose from. If `range` <= 1, returns `min`

  - min: number = 0

    The minimum integer to pick, default `0`

  #### Returns number

  A random integer between `min` and (`min` + `range` - 1)

  - Defined in src/battle-scene.ts:1235

### randomSpecies

- randomSpecies(
  waveIndex: number,
  level: number,
  fromArenaPool?: boolean,
  speciesFilter?: PokemonSpeciesFilter ,
  filterAllEvolutions?: boolean,
  ): default

  #### Parameters

  - waveIndex: number
  - level: number
  - `Optional` fromArenaPool: boolean
  - `Optional` speciesFilter: PokemonSpeciesFilter
  - `Optional` filterAllEvolutions: boolean

  #### Returns default

  - Defined in src/battle-scene.ts:2209

### redirectPokemonMoves

- redirectPokemonMoves(removedPokemon: default , allyPokemon: default ): void

  Used in doubles battles to redirect moves from one pokemon to another when one faints or is removed from the field

  #### Parameters

  - removedPokemon: default

    `Pokemon` the pokemon that is being removed from the field (flee, faint), moves to be redirected FROM

  - allyPokemon: default

    `Pokemon` the pokemon that will have the moves be redirected TO

  #### Returns void

  - Defined in src/battle-scene.ts:968

### removeModifier

- removeModifier(modifier: PersistentModifier , enemy?: boolean): boolean

  Removes a currently owned item. If the item is stacked, the entire item stack gets removed. This function does NOT apply in-battle effects, such as Unburden. If in-battle effects are needed, use `Pokemon.loseHeldItem` instead.

  #### Parameters

  - modifier: PersistentModifier

    The item to be removed.

  - enemy: boolean = false

    If `true`, remove an item owned by the enemy. If `false`, remove an item owned by the player. Default is `false`.

  #### Returns boolean

  `true` if the item exists and was successfully removed, `false` otherwise.

  - Defined in src/battle-scene.ts:3387

### removePartyMemberModifiers

- removePartyMemberModifiers(partyMemberIndex: number): Promise<void>

  #### Parameters

  - partyMemberIndex: number

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:3217

### removePokemonFromPlayerParty

- removePokemonFromPlayerParty(pokemon: PlayerPokemon , destroy?: boolean): void

  Removes a `PlayerPokemon` from the party, and clears modifiers for that Pokemon's id Useful for MEs/Challenges that remove Pokemon from the player party temporarily or permanently

  #### Parameters

  - pokemon: PlayerPokemon
  - destroy: boolean = true

    Default true. If true, will destroy the `PlayerPokemon` after removing

  #### Returns void

  - Defined in src/battle-scene.ts:1102

### reset

- reset(clearScene?: boolean, clearData?: boolean, reloadI18n?: boolean): void

  #### Parameters

  - clearScene: boolean = false
  - clearData: boolean = false
  - reloadI18n: boolean = false

  #### Returns void

  - Defined in src/battle-scene.ts:1239

### resetSeed

- resetSeed(waveIndex?: number): void

  #### Parameters

  - `Optional` waveIndex: number

  #### Returns void

  - Defined in src/battle-scene.ts:1913

### resumeBgm

- resumeBgm(): boolean

  #### Returns boolean

  - Defined in src/battle-scene.ts:2337

### sendTextToBack

- sendTextToBack(): void

  Pushes all Phaser.GameObjects.Text objects in the top right to the bottom of the canvas

  #### Returns void

  - Defined in src/battle-scene.ts:2176

### setFieldScale

- setFieldScale(scale: number, instant?: boolean): Promise<void>

  #### Parameters

  - scale: number
  - instant: boolean = false

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:1626

### setModifiersVisible

- setModifiersVisible(visible: boolean): void

  #### Parameters

  - visible: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:3328

### setPhaseQueueSplice

- setPhaseQueueSplice(): void

  Used by function unshiftPhase(), sets index to start inserting at current length instead of the end of the array, useful if phaseQueuePrepend gets longer with Phases

  #### Returns void

  - Defined in src/battle-scene.ts:2750

### setSeed

- setSeed(seed: string): void

  #### Parameters

  - seed: string

  #### Returns void

  - Defined in src/battle-scene.ts:1218

### shiftPhase

- shiftPhase(): void

  Is called by each Phase implementations "end()" by default We dump everything from phaseQueuePrepend to the start of of phaseQueue then removes first Phase and starts it

  #### Returns void

  - Defined in src/battle-scene.ts:2766

### showEnemyModifierBar

- showEnemyModifierBar(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2057

### showFieldOverlay

- showFieldOverlay(duration: number): Promise<void>

  #### Parameters

  - duration: number

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:1999

### showShopOverlay

- showShopOverlay(duration: number): Promise<void>

  #### Parameters

  - duration: number

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:2031

### toggleInvert

- toggleInvert(invert: boolean): void

  #### Parameters

  - invert: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:2676

### triggerPokemonBattleAnim

- triggerPokemonBattleAnim(
  pokemon: default ,
  battleAnimType: PokemonAnimType ,
  fieldAssets?: Sprite[],
  delayed?: boolean,
  ): boolean

  #### Parameters

  - pokemon: default
  - battleAnimType: PokemonAnimType
  - `Optional` fieldAssets: Sprite[]
  - delayed: boolean = false

  #### Returns boolean

  - Defined in src/battle-scene.ts:3577

### triggerPokemonFormChange

- triggerPokemonFormChange(
  pokemon: default ,
  formChangeTriggerType: Constructor < SpeciesFormChangeTrigger >,
  delayed?: boolean,
  modal?: boolean,
  ): boolean

  #### Parameters

  - pokemon: default
  - formChangeTriggerType: Constructor < SpeciesFormChangeTrigger >
  - delayed: boolean = false
  - modal: boolean = false

  #### Returns boolean

  - Defined in src/battle-scene.ts:3526

### tryRemovePhase

- tryRemovePhase(phaseFilter: (phase: Phase ) => boolean): boolean

  #### Parameters

  - phaseFilter: (phase: Phase ) => boolean

  #### Returns boolean

  - Defined in src/battle-scene.ts:2846

### tryRemoveUnshiftedPhase

- tryRemoveUnshiftedPhase(phaseFilter: (phase: Phase ) => boolean): boolean

  Will search for a specific phase in phaseQueuePrepend via filter, and remove the first result if a match is found.

  #### Parameters

  - phaseFilter: (phase: Phase ) => boolean

    filter function

  #### Returns boolean

  - Defined in src/battle-scene.ts:2859

### tryReplacePhase

- tryReplacePhase(phaseFilter: (phase: Phase ) => boolean, phase: Phase ): boolean

  #### Parameters

  - phaseFilter: (phase: Phase ) => boolean
  - phase: Phase

  #### Returns boolean

  - Defined in src/battle-scene.ts:2837

### trySpreadPokerus

- trySpreadPokerus(): void

  #### Returns void

  - Defined in src/battle-scene.ts:1884

### tryTransferHeldItemModifier

- tryTransferHeldItemModifier(
  itemModifier: PokemonHeldItemModifier ,
  target: default ,
  playSound: boolean,
  transferQuantity?: number,
  instant?: boolean,
  ignoreUpdate?: boolean,
  itemLost?: boolean,
  ): boolean

  Try to transfer a held item to another pokemon. If the recepient already has the maximum amount allowed for this item, the transfer is cancelled. The quantity to transfer is automatically capped at how much the recepient can take before reaching the maximum stack size for the item. A transfer that moves a quantity smaller than what is specified in the transferQuantity parameter is still considered successful.

  #### Parameters

  - itemModifier: PokemonHeldItemModifier

    `PokemonHeldItemModifier` item to transfer (represents the whole stack)

  - target: default

    `Pokemon` recepient in this transfer

  - playSound: boolean

    `true` to play a sound when transferring the item

  - transferQuantity: number = 1

    How many items of the stack to transfer. Optional, defaults to `1`

  - `Optional` instant: boolean

    ??? (Optional)

  - `Optional` ignoreUpdate: boolean

    ??? (Optional)

  - itemLost: boolean = true

    If `true`, treat the item's current holder as losing the item (for now, this simply enables Unburden). Default is `true`.

  #### Returns boolean

  `true` if the transfer was successful

  - Defined in src/battle-scene.ts:3106

### unshiftPhase

- unshiftPhase(...phases: Phase []): void

  Adds Phase(s) to the end of phaseQueuePrepend, or at phaseQueuePrependSpliceIndex

  #### Parameters

  - ...phases: Phase []

    `Phase` the phase(s) to add

  #### Returns void

  - Defined in src/battle-scene.ts:2720

### update

- update(): void

  This method should be overridden by your own Scenes.

  This method is called once per game step while the scene is running.

  #### Returns void

  Overrides SceneBase.update

  - Defined in src/battle-scene.ts:494

### updateAndShowText

- updateAndShowText(duration: number): void

  Displays the current luck value.

  #### Parameters

  - duration: number

    The time for this label to fade in, if it is not already visible.

  #### Returns void

  - Defined in src/battle-scene.ts:2112

### updateBiomeWaveText

- updateBiomeWaveText(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2065

### updateFieldScale

- updateFieldScale(): Promise<void>

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:1610

### updateGameInfo

- updateGameInfo(): void

  #### Returns void

  - Defined in src/battle-scene.ts:3626

### updateModifiers

- updateModifiers(player?: boolean, instant?: boolean): void

  #### Parameters

  - player: boolean = true
  - `Optional` instant: boolean

  #### Returns void

  - Defined in src/battle-scene.ts:3332

### updateMoneyText

- updateMoneyText(forceVisible?: boolean): void

  #### Parameters

  - forceVisible: boolean = true

  #### Returns void

  - Defined in src/battle-scene.ts:2075

### updatePartyForModifiers

- updatePartyForModifiers(party: default [], instant?: boolean): Promise<void>

  #### Parameters

  - party: default []
  - `Optional` instant: boolean

  #### Returns Promise<void>

  - Defined in src/battle-scene.ts:3363

### updateScoreText

- updateScoreText(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2103

### updateShopOverlayOpacity

- updateShopOverlayOpacity(value: number): void

  #### Parameters

  - value: number

  #### Returns void

  - Defined in src/battle-scene.ts:2023

### updateSoundVolume

- updateSoundVolume(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2345

### updateUIPositions

- updateUIPositions(): void

  #### Returns void

  - Defined in src/battle-scene.ts:2154

### validateAchv

- validateAchv(achv: Achv , args?: unknown[]): boolean

  #### Parameters

  - achv: Achv
  - `Optional` args: unknown[]

  #### Returns boolean

  - Defined in src/battle-scene.ts:3599

### validateAchvs

- validateAchvs(achvType: Constructor < Achv >, ...args: unknown[]): void

  #### Parameters

  - achvType: Constructor < Achv >
  - ...args: unknown[]

  #### Returns void

  - Defined in src/battle-scene.ts:3592

### validateVoucher

- validateVoucher(voucher: Voucher , args?: unknown[]): boolean

  #### Parameters

  - voucher: Voucher
  - `Optional` args: unknown[]

  #### Returns boolean

  - Defined in src/battle-scene.ts:3615